// blend1.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <math.h>


#ifdef _MANAGED
#pragma managed(push, off)
#endif



extern "C" {
typedef unsigned char n_byte;

int __stdcall get_blend_func_count();
char* __stdcall get_blend_func_key(int no);
char* __stdcall get_blend_func_name(int no);
void __stdcall blend(unsigned char* dst,const unsigned char* col,const unsigned char* alpha,int col_step
								 ,int alpha_step,int num_channel,int num_pixel,int no);



//ǉ鍇@̐ԂB
int __stdcall get_blend_func_count()
{
    return 1;
}


//psdt@CɕۑƂkeyԂB
/*
'norm' = normal
'dark' = darken
'lite' = lighten
'hue ' = hue
'sat ' = saturation
'colr' = color
'lum ' = luminosity
'mul ' = multiply
'scrn' = screen
'diss' = dissolve
'over' = overlay
'hLit' = hard light
'sLit' = soft light
'diff' = difference
'smud' = exlusion
'div ' = color dodge
'idiv' = color burn
*/
char* __stdcall get_blend_func_key(int no) 
{
	if (no == 0) {
		return "diff";
	}
	return 0;
}

//@̖OԂB
char* __stdcall get_blend_func_name(int no)
{
	if (no == 0) {
		return "̐Βl";
	}
	return "";
}


//s֐B
//num_channel `lBO[[h̏ꍇ͂PAJ[[h̏ꍇ͂R

void __stdcall blend(unsigned char* dst,const unsigned char* col,const unsigned char* alpha,int col_step,int alpha_step
					,int num_channel,int num_pixel,int no)
{
	if (no == 0) {//̐Βl
		if (num_channel == 1) {
			const unsigned char* col_end = col + num_pixel * col_step;
			while (col < col_end) {
				*dst = (unsigned char)abs(*dst - (*col * *alpha) / 255);

				alpha += alpha_step;
				col += col_step;
				dst += col_step;
			}
		}
		else if (num_channel == 3) {
			const unsigned char* col_end = col + num_pixel * col_step;
			while (col < col_end) {
				*dst = (unsigned char)abs(*dst - (*col * *alpha) / 255);
				*(dst + 1) = (unsigned char)abs(*(dst + 1) - (*(col + 1) * *alpha) / 255);
				*(dst + 2) = (unsigned char)abs(*(dst + 2) - (*(col + 2) * *alpha) / 255);

				alpha += alpha_step;
				col += col_step;
				dst += col_step;
			}
		}
	}

}

//̃C[ƌŎgp
void __stdcall merge(n_byte* dst,const n_byte* col,const n_byte* base_col,const n_byte* alpha,const n_byte* base_alpha
					 ,int col_step,int alpha_step,int base_alpha_step,int num_channel,int num_pixel,int no)
{
	if (no == 0) {
		if (num_channel == 1) {
			const unsigned char* col_end = col + num_pixel * col_step;
			while (col < col_end) {
				unsigned int a0 = *base_alpha;
				unsigned int a1 = *alpha;

				if (a1 != 0) {
					*dst = (unsigned char)abs((int)(*base_col * a0 - *col * a1) / 255);

					*(dst + 1) = n_byte(((a0 + a1) * 255 - a0 * a1) / 255);	
				}
				else {
					*dst = *base_col;
					*(dst + 1) = *base_alpha;
				}

				dst += 2;
				col += col_step;
				base_col += col_step;
				alpha += alpha_step;
				base_alpha += alpha_step;
			}
		}
		else if (num_channel == 3) {
			const unsigned char* col_end = col + num_pixel * col_step;
			while (col < col_end) {
				unsigned int a0 = *base_alpha;
				unsigned int a1 = *alpha;

				if (a1 != 0) {
					*dst = (unsigned char)abs((int)(*base_col * a0 - *col * a1) / 255);
					*(dst + 1) = (unsigned char)abs((int)(*(base_col + 1) * a0 - *(col + 1) * a1) / 255);
					*(dst + 2) = (unsigned char)abs((int)(*(base_col + 2) * a0 - *(col + 2) * a1) / 255);

					*(dst + 3) = n_byte(((a0 + a1) * 255 - a0 * a1) / 255);	
				}
				else {
					*dst = *base_col;
					*(dst + 1) = *(base_col + 1);
					*(dst + 2) = *(base_col + 2);
					*(dst + 3) = *base_alpha;
				}

				dst += 4;
				col += col_step;
				base_col += col_step;
				alpha += alpha_step;
				base_alpha += base_alpha_step;
			}
		}
	}
}



}
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

