
void draw_grid()
{
	np_cmd(NP_NEW_LAYER);

	np_canvas c = get_active_canvas();
	np_image img = get_active_image();

	int w = get_width(img);
	int h = get_height(img);

	double old_brush_size = get_brush_size();//uVTCY擾
	set_brush_size(2);

	int divx = 4;
	for (int i = 0; i <= divx; ++i) {
		draw_line(c,i * w / divx, 0, i * w / divx,h);
	}
	int divy = 4;
	for (int j = 0; j <= divy; ++j) {
		draw_line(c,0,j * h / divy,w,j * h / divy);
	}
	
	set_brush_size(old_brush_size);//uVTCY߂
}

void open_image_grid(string file_name,bool v)
{
	open_image(file_name,v ? 5 : 6);

	np_image img = get_active_image();

	if (!v) {
		set_opacity(get_active_layer(img),127);
	}
	set_visible(get_active_layer(img),v);


	draw_grid();


	set_name(img,"");
	set_confirm_save_changes(img,false);//鎞Aۑ邩mFȂ
	
	np_cmd(NP_NEW_LAYER);
}


void grid_copy()
{
	string file_name = get_open_file_name();//_CAO{bNX\āAJt@C擾
	if (file_name != "") {
		open_image_grid(file_name,false);
		open_image_grid(file_name,true);
	}
	
}